<template>
    <div class="expert-page">
         <el-button type="text" class="expert-page__back" @click="goBack()">
            <i class="el-icon-d-arrow-left">BACK</i>
        </el-button>
        <template v-if="dataIsLoaded">
            <h2>{{pageTitle}}</h2>
            <expert-param-list :config="config" :data="expert" ref="paramList" />
            <actions-panel v-if="detailsEdited" :actions="actions"  @save="saveChanges" @discard="discardChanges" />
            <error-scroll-mover />
        </template>
    </div>
</template>

<script>
import { mapState } from 'vuex';
import { detailsFields } from '@/constants/ui/details/expert';
import { PanelActions } from '@/constants/ui/details';
import ExpertParamList from '@/components/ExpertParamList';
import ActionsPanel from '@bloomio/spa-admin-common/components/actions-panel';
import ErrorScrollMover from '@/components/ErrorScrollMover';

export default {
    components: {
        ExpertParamList,
        ActionsPanel,
        ErrorScrollMover,
    },
    beforeCreate() {
        this.initLoading(this.$store.dispatch('experts/getDetails', { id: this.$route.params.expertId }).then(() => {
            this.dataIsLoaded = true;
        }));
    },
    watch: {
        expert(newVal) {
            document.title = `Expert: ${this.$route.params.expertId} ${this.fullname} ${newVal.email}`;
        },
        blockSubmit(newVal) {
            const saveAction = this.actions.find(a => a.event === 'save');
            if (saveAction) {
                saveAction.disabled = newVal;
            }
        },
    },
    data() {
        return {
            dataIsLoaded: false,
            config: detailsFields,
            actions: [...PanelActions],
        };
    },
    computed: {
        ...mapState('experts', {
            expert: state => state.current,
        }),
        fullname: vm => ((vm.expert.first_name || vm.expert.last_name) ? `${vm.expert.first_name} ${vm.expert.last_name}` : ''),
        pageTitle: vm => (vm.fullname ? `Expert ${vm.fullname}` : 'Nameless expert'),
        detailsEdited: vm => vm.$store.getters['experts/isParamsEdited'],
        blockSubmit: vm => vm.$store.getters.blockSubmit,
    },
    methods: {
        /**
         * Go to the expert listing or previous page
         */
        goBack() {
            if (this.$router.isFirstPage) {
                this.$router.push({ name: 'experts' });
            } else {
                this.$router.go(-1);
            }
        },
        /**
         * Send new details to server
         * @param {Object} action - activated button from ActionsPanel component
         */
        saveChanges() {
            const actionPromise = this.$store.dispatch('experts/submitDetails', { id: this.$route.params.expertId }).then(() => {
                this.discardChanges();
            });
            this.initLoading(actionPromise);
        },
        /**
         * Discard changes for all sections and components on details page
         */
        discardChanges() {
            if (this.$refs.paramList) {
                this.$refs.paramList.resetEditedParams();
            }
        },
    },
};
</script>

<style lang="stylus" scoped>
.expert-page
    padding-bottom: 2rem
    position: relative

.expert-page__back
    font-size: 1.2rem
    font-weight: bold
    margin-bottom: 2rem
</style>
